/*

    File: file_asf.c

    Copyright (C) 1998-2006 Christophe GRENIER <grenier@cgsecurity.org>
  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#ifdef HAVE_STRING_H
#include <string.h>
#endif
#include <stdio.h>
#include "types.h"
#include "photorec.h"

static const char* header_check_asf(const unsigned char *buffer, const unsigned int buffer_size, const unsigned int safe_header_only,  t_file_recovery *file_recovery);
//static void file_check_asf(t_file_recovery *file_recovery);

const t_file_hint file_hint_asf= {
  .extension="asf",
  .description="ASF, WMA, WMV: Advanced Streaming Format used for Audio/Video",
  .min_header_distance=0,
  .min_filesize=0,
  .max_filesize=PHOTOREC_MAX_FILE_SIZE,
  .recover=1,
  .header_check=&header_check_asf,
  .data_check=NULL,
//  .file_check=&file_check_asf
  .file_check=NULL
};

static const char* header_check_asf(const unsigned char *buffer, const unsigned int buffer_size, const unsigned int safe_header_only,  t_file_recovery *file_recovery)
{
  const unsigned char asf_header[4]= { 0x30,0x26,0xB2,0x75};
  if(memcmp(buffer,asf_header,sizeof(asf_header))==0)
    return file_hint_asf.extension;
  return NULL;
}

/*
static void file_check_asf(t_file_recovery *file_recovery)
{
  const unsigned char asf_footer[6]= {0xa1, 0xdc, 0xab, 0x8c, 0x47, 0xa9};
  file_search_footer(file_recovery, asf_footer,sizeof(asf_footer));
}
*/
